#!/bin/sh

case `uname -m` in
  x86_64)
    LDDIR=/lib32
    LDFLAGS=-melf_i386
    ;;
  i[3-6]86)
    LDDIR=/lib
    LDFLAGS=
    ;;
esac

LDLIB=$LDDIR/ld-linux.so.2

LZMAOPT="-c -m32 -nostdlib"
APP="kpack"

cd lzma_c
rm *.o *.a
gcc ${LZMAOPT} LZMAEncoder.c
gcc ${LZMAOPT} MatchFinder.c
gcc ${LZMAOPT} RangeCoder.c
ar cru lzmapack.a *.o
ranlib lzmapack.a

cd ..
rm -f ${APP} ${APP}.o && \
fasm ${APP}.asm && \
ld ${LDFLAGS} -lc -e _start -dynamic-linker ${LDLIB} ${APP}.o lzma_c/lzmapack.a -o ${APP} && \
strip -s ${APP} && \
./${APP} calc.bin b
